<%--
   This file is based on /components/emxLaunch3DPlay.jsp available from Dassault Systemes.
--%>
<%@ page import="com.matrixone.apps.common.Part" %>
<%@ page import="com.matrixone.apps.domain.DomainObject" %>
<%@ page import="com.matrixone.servlet.Framework" %>
<%@ page import="com.technia.tvc.core.db.aef.AEFUtils" %>
<%@ page import="com.technia.tvc.core.util.RequestParameters" %>
<%@ page import="com.technia.tvc.core.util.RequestUtils" %>
<%@ page import="matrix.db.Context" %>
<%@ page import="matrix.util.StringList" %>
<%@ page import="java.util.Map" %>
<%@ page import="com.technia.tvc.core.db.select.Statement" %>

<!DOCTYPE html>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<html style="height: 100%; overflow: hidden;">
    <head>
        <script src="<c:url value='/webapps/AmdLoader/AmdLoader.js'/>"></script>
        <script src="<c:url value='/common/scripts/jquery-latest.js'/>"></script>
        <script src="<c:url value='/webapps/c/UWA/js/UWA_W3C_Alone.js'/>"></script>
        <style>
            .error {
                font-family: arial, sans-serif;
                position: relative;
                min-height: 1em;
                margin: 1em 0;
                background: #F8F8F9;
                padding: 1em 1.5em;
                line-height: 1.4285em;
                color: rgba(0,0,0,0.87);
                -webkit-transition: opacity 0.1s ease, color 0.1s ease, background 0.1s ease, box-shadow 0.1s ease;
                transition: opacity 0.1s ease, color 0.1s ease, background 0.1s ease, box-shadow 0.1s ease;
                border-radius: 0.28571429rem;
                box-shadow: 0 0 0 1px rgba(34,36,38,0.22) inset, 0 0 0 0 transparent;
                display: none;
            }
            #divPageBody {
                top: 0;
                bottom: 200px;
                width:100%;
                height:100%;
            }
            body {
                height: 100%;
                margin: 0;
            }
        </style>

        <%
            String objectId = RequestUtils.getParameter(request, RequestParameters.OBJECT_ID_PARAM);
            String physicalId = "";
            String type = "";
            String serverUrl = Framework.getFullClientSideURL(request, null, "");
            DomainObject domainObject = new DomainObject(objectId);
            Context context = AEFUtils.getContext(session);
            if (domainObject.isKindOf(context, "Part")) {
                Part part = new Part(objectId);
                Map partSpecMap = part.getInfoMap(context);
                System.out.println(partSpecMap);
                physicalId = (String) partSpecMap.get(Statement.PHYSICALID.getStatement());
                type = (String) partSpecMap.get(Statement.TYPE.getStatement());
            } else {
                StringList selects = new StringList();
                selects.addElement(Statement.PHYSICALID.getStatement());
                selects.addElement(Statement.TYPE.getStatement());
                Map objMap = domainObject.getInfo(context, selects);
                physicalId = (String) objMap.get(Statement.PHYSICALID.getStatement());
                type = (String) objMap.get(Statement.TYPE.getStatement());
            }
        %>
        <script>
            var viewer, subscribe;

            function cb3DPlayReady(e) {
                e.target.removeEventListener('3DPLAYREADY', arguments.callee, false);
                viewer = e.detail.helper;
                if (viewer && subscribe) {
                    window.parent.viewer = viewer;
                }
            }

            function cbBomReady(e, obj) {
                subscribe = obj.subscribe;
                if (viewer && subscribe) {
                    subscribe(viewer, true);
                }
            }

            window.top.document.addEventListener('3DPLAYREADY', cb3DPlayReady, false);
            window.$(window.top.document).on("BOMREADY", cbBomReady);

            require([
                'DS/3DPlayHelper/3DPlayHelper'
            ], function (Player3DPlayWeb) {
                p = Player3DPlayWeb({
                    container: 'divPageBody',
                    input: {
                        asset: {
                            provider: 'EV6',
                            physicalid: '<%=physicalId%>',
                            dtype: '<%=type%>',
                            serverurl: '<%=serverUrl%>'
                        }
                    },
                    options: {
                        loading: 'autoplay'
                    }
                });
            }, function(err) {
               $('#unavailable').show();
            });
        </script>
    </head>

    <body>
        <div id="divPageBody" name="divPageBody">
            <div class="error" id="unavailable">
                Unable to render viewer since 3DPlay is not available.
            </div>
        </div>
    </body>
</html>
